//
//  itoanm.c
//
//  Like an itoa()
//  Copyright (C) 2009 Toyohiko Togashi tog001@nifty.com
//
//
//  This program is free software; you can redistribute it and/or modify it under the terms of the
//  GNU General Public License as published by the Free Software Foundation; either version 3
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along with this program.
//  If not, see <http://www.gnu.org/licenses/>
//
//
//	Description
//		Convert int to char string.
//		Right align and virtual fixed point.
//		Not support base number.
//		n: column width, m: under point column
//		ex:	itoanm( 1234, buf, 6, 2)  -->  buf == " 12.34"
//			itoanm(    4, buf, 6, 1)  -->  buf == "   0.4"
//			itoanm(-1234, buf, 6, 0)  -->  buf == "-1234."
//			itoanm( 1234, buf, 6,-1)  -->  buf == "  1234"
//
//
//    Update history
//    ---------- ----- -------------------------------------------
//    2009.10.06 v0.1  First cording
//
//char *
void itoanm(int i, char *a, char n, char m) {
	char *p;
	char s;

	m++;
	s = 0;
	if (i < 0) {
		s = 1;
		i = -i;
	}

	p = a + n;
	*p = '\0';
	while(--n >= 0) {
		if (--m == 0) {
			*(--p) = '.';
		} else {
			*(--p) = i % 10 + '0';
			i /= 10;
		}
		if ((i == 0) && (m < 0)) break;
	}
	if (s) {
		if (n > 0) {
			*(--p) = '-';
			--n;
		}
	}
	while(--n >= 0) {
		*(--p) = ' ';
	}
	return;
//	return(a);
}

